#!/usr/bin/env bash

green='\e[0;32m'
red='\e[0;31m'
NC='\e[0m' # No Color
# echo -e "${red}Hello Stackoverflow${NC}"

if (($#>0)); then
  files=("$@")
else
  files=$(ls *.xml)
fi
echo ${files}

gmax="3.5"

for i in ${files}; do

echo "Species :" $i

rmt=$(grep -oP 'radius="\K[^"]*' $i)
rgkmax=$(echo "${rmt}*${gmax}" | bc -l)
# echo ${rgkmax}

cat > input.xml << EOF
<input>
  <title>Test</title>
  <structure speciespath="./">
    <crystal>
      <basevect>8.0 0.0 0.0</basevect>
      <basevect>0.0 8.0 0.0</basevect>
      <basevect>0.0 0.0 8.0</basevect>
    </crystal>
    <species speciesfile="$i">
      <atom coord="0.0 0.0 0.0"></atom>
    </species>
  </structure>
  <groundstate
    do="fromscratch"
    rgkmax="${rgkmax}"
    ngridk="1 1 1"
    xctype="LDA_PW"
    maxscl="100"
    >
  </groundstate>
</input>
EOF

if test -x ../bin/excitingmpi ; then
  time ../bin/excitingmpi input.xml
elif test -x ../bin/excitingser ; then
  time ../bin/excitingser input.xml
else
  echo "Missing exciting executable"
  exit
fi

if grep "Convergence targets achieved" INFO.OUT > /dev/null
then
   echo -e "${green}Test Passed${NC}"
else
   echo -e "${red}Test Failed${NC}"
fi

done

exit